backend/models/Ad.php
<?php

namespace backend\models;

use Yii;
use yii\helpers\Url;
use backend\models\AdImage;
use backend\models\AdMenu;
use backend\models\CategoryAdOrder;

/**
 * This is the model class for table "ad".
 *
 * @property string $pkAdID
 * @property string $fkCategoryID
 * @property integer $position
 * @property integer $active
 * @property integer $dinning
 * @property string $title
 * @property string $subTitle
 * @property string $header
 * @property string $description
 * @property string $address
 * @property string $streetName
 * @property string $cityName
 * @property string $countryName
 * @property string $latitude
 * @property string $longitude
 * @property string $contactNumber
 * @property string $startDate
 * @property string $startDateTime
 * @property string $endDate
 * @property string $endDateTime
 * @property string $timestamp
 *
 * @property Category $fkCategory
 * @property AdImage[] $adImages
 * @property AdMenu[] $adMenus
 */
class Ad extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public $catID;
    public $menuHeader;
    public $adStatus;
    public $deleteAdID;
    public $adImgType;
    public $positionCatId;
    public $positionArray;

    public static function tableName()
    {
        return 'ad';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['fkCategoryID', 'active', 'dinning'], 'integer'],
            [['fkCategoryID','title','address', 'cityName', 'countryName','description','header','contactNumber','startDate', 'startDateTime', 'endDate', 'endDateTime','latitude', 'longitude'], 'required'],
            [['title', 'subTitle', 'streetName', 'cityName', 'countryName'], 'string', 'max' => 100],
            [['header','videoPath', 'reservationImage'], 'string', 'max' => 200],
            [['catID','menuHeader','adStatus','deleteAdID','adImgType', 'latitude', 'longitude','positionArray','positionCatId'], 'safe'],
            [['description', 'address','reservationMessage'], 'string', 'max' => 1000],
            [['contactNumber', 'startDate', 'startDateTime', 'endDate', 'endDateTime'], 'string', 'max' => 20],
            [['fkCategoryID'], 'exist', 'skipOnError' => true, 'targetClass' => Category::className(), 'targetAttribute' => ['fkCategoryID' => 'pkCategoryID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'pkAdID' => 'Pk Ad ID',
            'fkCategoryID' => 'Category',
            'active' => 'Active',
            'dinning' => 'Dinning',
            'title' => 'Title',
            'subTitle' => 'Sub Title',
            'header' => 'Header',
            'description' => 'Description',
            'address' => 'Address',
            'streetName' => 'Street Name',
            'cityName' => 'City Name',
            'countryName' => 'Country Name',
            'latitude' => 'Latitude',
            'longitude' => 'Longitude',
            'contactNumber' => 'Contact Number',
            'videoPath' => 'Video Path',
            'reservationImage' => 'Reservation Image',
            'reservationMessage' => 'Reservation Message',
            'startDate' => 'Start Date',
            'startDateTime' => 'Start Date Time',
            'endDate' => 'End Date',
            'endDateTime' => 'End Date Time',
            'timestamp' => 'Timestamp',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getFkCategory()
    {
        return $this->hasOne(Category::className(), ['pkCategoryID' => 'fkCategoryID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getAdImages()
    {
        return $this->hasMany(AdImage::className(), ['fkAdID' => 'pkAdID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getAdMenus()
    {
        return $this->hasMany(AdMenu::className(), ['fkAdID' => 'pkAdID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getCategoryAdOrders()
    {
        return $this->hasMany(CategoryAdOrder::className(), ['fkAdID' => 'pkAdID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getReservations()
    {
        return $this->hasMany(Reservation::className(), ['fkAdID' => 'pkAdID']);
    }
    

    public function checkDinning($params)
    {
        $this->load(array('Ad' => $params));
                
            $checkDinning = Category::find()->where(['dinning' => '1', 'pkCategoryID' => $this->catID])->one();
        
        if($checkDinning)
        {
            $arr['categoryName'] = $checkDinning->categoryName;
        }
        else
        {
            $arr['categoryName'] = '';
        }
        return json_encode($arr);
    }

    public function insertAd($param)
    {
          //echo '<pre>'; print_r($_FILES); echo '</pre>'; die;
          //echo '<pre>'; print_r($this); echo '</pre>'; die;
           
            $time = time();
            $this->timestamp = $time;

            // $address = trim($this->address);
            // $address = str_replace(" ", "+", $address);
            // $streetName = trim($this->streetName);
            // $streetName = str_replace(" ", "+", $streetName);
            // $cityName = trim($this->cityName);
            // $cityName = str_replace(" ", "+", $cityName);
            // $countryName = trim($this->countryName);
            // $countryName = str_replace(" ", "+", $countryName);
            
            // $myAddress = $address.','.$streetName.','.$cityName.','.$countryName;
            // $jsonAddress = file_get_contents("http://maps.google.com/maps/api/geocode/json?address=$myAddress&sensor=false");
            // $addressLatLong = json_decode($jsonAddress);

            // if(isset($addressLatLong->results[0]->geometry->location))
            // {
            // $latitude = (isset($addressLatLong->results[0]->geometry->location->lat)) ? $addressLatLong->results[0]->geometry->location->lat : NULL;
            // $longitude = (isset($addressLatLong->results[0]->geometry->location->lng)) ? $addressLatLong->results[0]->geometry->location->lng : NULL;

            // $this->latitude = $latitude;
            // $this->longitude = $longitude;
            // }

            $categoryID = $this->fkCategoryID;
            $dinningCategory = $this->dinning;
            $menuHeader = $this->menuHeader;
            
            if(@$_FILES['adVideo']['name'])
            {
                $adVideo = self::uploadVideo($_FILES['adVideo']);
                    if($adVideo['fileName'])
                    {
                        $this->videoPath = $adVideo['fileName'];
                    }
            }

            if(@$_FILES['reservationImage']['name'])
            {
                $reservationImage = self::uploadReservationImage($_FILES['reservationImage']);
                    if($reservationImage['fileName'])
                    {
                        $this->reservationImage = $reservationImage['fileName'];
                    }
            }

            if($this->save())
            {
                $adID  = $this->pkAdID;

                if($param == 'create')
                {
                    $position = CategoryAdOrder::find()->where(['fkCategoryID' => $categoryID])->max('position');    
                    $addPosition = new CategoryAdOrder();
                    $addPosition->fkAdID = $adID;
                    $addPosition->fkCategoryID = $categoryID;
                    $addPosition->position = $position + 1;

                    $addPosition->save();
                }

                if($param == 'update')
                {
                    $update = AdImage::updateAll(['fkCategoryID' => $categoryID], 'fkAdID = '.$adID);
                }

                if($dinningCategory == '1')
                {
                    if(@$_FILES['menuPDF']['name'])
                    {
                        $menuPDF = self::uploadPDF($_FILES['menuPDF']);
                        if($menuPDF['fileName'])
                        {
                            $pdfPath = $menuPDF['fileName'];

                            if($param == 'create')
                            {
                                $AdMenu = new AdMenu();    
                            }
                            else
                            {
                                $AdMenu = AdMenu::find()->where(['fkAdID' => $adID, 'fkCategoryID' => $categoryID])->one();
                                if(!$AdMenu)
                                {
                                    $AdMenu = new AdMenu();
                                }
                            }
                            
                            $AdMenu->menuPdfPath = $pdfPath;
                            $AdMenu->fkAdID = $adID;
                            $AdMenu->fkCategoryID = $categoryID;
                            $AdMenu->save();

                        }
                    }

                    if($param == 'update')
                    {
                        $AdMenu = AdMenu::find()->where(['fkAdID' => $adID, 'fkCategoryID' => $categoryID])->one();
                        if($AdMenu)
                        {

                            $AdMenu->fkAdID = $adID;
                            $AdMenu->fkCategoryID = $categoryID;
                            $AdMenu->menuHeader = $menuHeader;
                            $AdMenu->save();
                        }
                    }
                }
                

                if(@$_FILES['splashImage']['name'])
                {
                    $splashImage = self::uploadImage($_FILES['splashImage']);
                        if($splashImage['fileName'])
                        {
                            $imagePath = $splashImage['fileName'];

                            if($param == 'create')
                            {

backend/controllers/AdController.php
<?php

namespace backend\controllers;

use Yii;
use backend\models\Ad;
use backend\models\AdSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;

/**
 * AdController implements the CRUD actions for Ad model.
 */
class AdController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['login','check-dinning','position','set-position','delete-ad','delete-video','delete-reservation-image'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['view', 'index','create','update','delete','check-dinning','position','set-position','delete-ad','delete-reservation-image'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
        ];
    }

    /**
     * Lists all Ad models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new AdSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Ad model.
     * @param string $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModelCustom($id),
        ]);
    }

    /**
     * Creates a new Ad model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Ad();
        $model->active = '1';
        $model->adStatus = 'create';
        if ($model->load(Yii::$app->request->post()) && $model->insertAd('create')) {
            return $this->redirect(['view', 'id' => $model->pkAdID]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Ad model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModelCustom($id);
        $model->adStatus = 'update';
        if ($model->load(Yii::$app->request->post()) && $model->insertAd('update')) {
            return $this->redirect(['view', 'id' => $model->pkAdID]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Ad model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Ad model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $id
     * @return Ad the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Ad::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    protected function findModelCustom($id)
    {
        if (($model = Ad::find()->joinWith(['adMenus','fkCategory'])->where(['ad.pkAdID' => $id])->one()) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    public function actionCheckDinning()
    {
        $values = Yii::$app->request->post();
        $model = new Ad();
        $response = $model->checkDinning($values);
        return $response;
    }

    public function actionDeleteAd()
    {
        
        $values = Yii::$app->request->post();
        $model = new Ad();
        $response = $model->deleteAd($values);
        return $response;
    }

    public function actionDeleteVideo()
    {
        $values = Yii::$app->request->post();
        $model = new Ad();
        $response = $model->deleteVideo($values);
        return $response;
    }

    public function actionDeleteReservationImage()
    {
        $values = Yii::$app->request->post();
        $model = new Ad();
        $response = $model->deleteReservationImage($values);
        return $response;
    }

    
    public function actionPosition()
    {
        $values = Yii::$app->request->post();
        if(isset($values['selectAdOrder']))
        {
            $id = $values['selectAdOrder'];
        }
        else
        {
            $id = NULL;
        }
        $model = new Ad();
        $response = $model->getAllAds($id);
        $response['formCategoryID'] = $id;
        return $this->render('position', [
                'model' => $response,
            ]);
    }

    public function actionSetPosition()
    {
        $values = Yii::$app->request->post();
        //print_r($values); die;
        $model = new Ad();
        $response = $model->setPosition($values);
        return $response;
    }


}

backend/views/ad/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\Category;

/* @var $this yii\web\View */
/* @var $model backend\models\AdSearch */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="col-md-12 searchCat">
<div class="box">
<div class="box-header">
<h3>Search</h3>
</div>

<div class="box-body">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <div class="row">
    <div class="col-lg-3 col-sm-4">
    <?php
    $items = ArrayHelper::map(Category::find()->orderBy(['position' => SORT_ASC])->all(), 'pkCategoryID', 'categoryName');
          
    echo $form->field($model, 'fkCategoryID')->dropdownList($items,
    ['prompt'=>'Select Category'])->label(false);
    ?>
         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'title')->textInput()->input('text', ['placeholder' => "Ad Title"])->label(false); ?>
         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'dinning')->dropDownList(['' => 'Select Dinning', '1' => 'Yes', '0' => 'No'])->label(false); ?>
         </div>
         <div class="col-lg-3 col-sm-4">
<?php echo $form->field($model, 'active')->dropDownList(['' => 'Select Active Status', '1' => 'Yes', '0' => 'No'])->label(false); ?>
         </div>

    <div class="col-lg-3 col-sm-4">
        <?= Html::submitButton('Search', ['class' => 'btn btn-info']) ?>
    </div>

    <?php ActiveForm::end(); ?>
    </div>
</div>
</div>
</div>

backend/views/ad/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model backend\models\Ad */

$this->title = 'Add Ad';
//$this->params['breadcrumbs'][] = ['label' => 'Ads', 'url' => ['index']];
//$this->params['breadcrumbs'][] = $this->title;
?>
<section class="content-header">
        <h1><?= Html::encode($this->title) ?></h1>
    </section>

<section class="content">
    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>
 </section>

backend/views/ad/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use backend\models\Category;
use backend\models\AdImage;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\AdSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'All Ads';
//$this->params['breadcrumbs'][] = $this->title;
?>

<section class="content-header">
        <h1><?= Html::encode($this->title) ?></h1>
    </section>

<section class="content">
<div class="col-md-6">

        <?= Html::a('Create Ad', ['create'], ['class' => 'btn btn-success']) ?>
        <?= Html::a('Set Order', ['position'], ['class' => 'btn btn-info']) ?>
    </div>
<?php echo $this->render('_search', ['model' => $searchModel]); ?>
    <div class="col-md-12">
    <div class="box">
    <div class="box-body">


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        //'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            [
                'attribute' => 'Ad Title',
                'value' => function($dataProvider){ 
                    $url = Url::to(['ad/view']);
                    $finalUrl = $url.'?id='.$dataProvider->pkAdID;
                        return '<u><a href="'.$finalUrl.'">'.$dataProvider->title.'</a></u>';
                },
                'format' => 'html'
            ],
            [
                'attribute' => 'Category Name',
                'value' => function($dataProvider){ 
                        $url = Url::to(['category/view']);
                        $finalUrl = $url.'?id='.$dataProvider->fkCategory->pkCategoryID;
                      $catName = $dataProvider->fkCategory->categoryName;
                      return '<u><a href="'.$finalUrl.'"><span class="adInfo">'.$catName.'</span></a></u>';
                },
                'format' => 'html'
            ],
            [
                'header' => 'Order<br>(Cat wise)',
                'attribute' => 'Order',
                'value' => function($dataProvider){
                    //echo '<pre>'; print_r($dataProvider->categoryAdOrders[0]->position); echo '</pre>';
                        return '<span class="positionInfo">'.$dataProvider->categoryAdOrders[0]->position.'</span>';
                },
                'format' => 'html'
                            
            ],
            [
                'attribute' => 'Dinning',
                'value' => function($dataProvider){ 
                    if ($dataProvider->dinning == '1')
                        return '<i class="fa fa-check" aria-hidden="true"></i>';
                    else
                        return '<i class="fa fa-times" aria-hidden="true"></i>';
                },
                'format' => 'html'
                            
            ],
            [
                'attribute' => 'Active',
                'value' => function($dataProvider){ 
                    if ($dataProvider->active == '1')
                        return '<i class="fa fa-check" aria-hidden="true"></i>';
                    else
                        return '<i class="fa fa-times" aria-hidden="true"></i>';
                },
                'format' => 'html'
                            
            ],
            [
                'attribute' => '360 Video',
                'value' => function($dataProvider){ 
                    if ($dataProvider->videoPath)
                        return '<i class="fa fa-check" aria-hidden="true"></i>';
                    else
                        return '<i class="fa fa-times" aria-hidden="true"></i>';
                },
                'format' => 'html'
                            
            ],
            [
                'attribute' => 'Splash Image',
                'value' => function($dataProvider){ 
                    $splashImage = AdImage::find()->where(['fkAdID' => $dataProvider->pkAdID, 'imageType' => 'splashImage'])->one();
                        if(isset($splashImage->imagePath))
                        return '<i class="fa fa-check" aria-hidden="true"></i>';
                        else
                        return '<i class="fa fa-times" aria-hidden="true"></i>';
                },
                'format' => 'html'
                            
            ],
            [
                'attribute' => 'Main Image',
                'value' => function($dataProvider){ 
                    $splashImage = AdImage::find()->where(['fkAdID' => $dataProvider->pkAdID, 'imageType' => 'mainImage'])->one();
                        if(isset($splashImage->imagePath))
                        return '<i class="fa fa-check" aria-hidden="true"></i>';
                        else
                        return '<i class="fa fa-times" aria-hidden="true"></i>';
                },
                'format' => 'html'
                            
            ],
            [
                'attribute' => 'Left Image',
                'value' => function($dataProvider){ 
                    $splashImage = AdImage::find()->where(['fkAdID' => $dataProvider->pkAdID, 'imageType' => 'leftImage'])->one();
                        if(isset($splashImage->imagePath))
                        return '<i class="fa fa-check" aria-hidden="true"></i>';
                        else
                        return '<i class="fa fa-times" aria-hidden="true"></i>';
                },
                'format' => 'html'
                            
            ],
            [
                'attribute' => 'Right Image',
                'value' => function($dataProvider){ 
                    $splashImage = AdImage::find()->where(['fkAdID' => $dataProvider->pkAdID, 'imageType' => 'rightImage'])->one();
                        if(isset($splashImage->imagePath))
                        return '<i class="fa fa-check" aria-hidden="true"></i>';
                        else
                        return '<i class="fa fa-times" aria-hidden="true"></i>';
                },
                'format' => 'html'
                            
            ],

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>

    </div>
    </div>
    </div>


</section>

backend/views/ad/position.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use backend\models\Category;
use yii\widgets\ActiveForm;


/* @var $this yii\web\View */
/* @var $searchModel backend\models\CategorySearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'All Ads';
//$this->params['breadcrumbs'][] = $this->title;
?>
<section class="content-header">
        <h1><?= Html::encode($this->title) ?></h1>
    </section>
    
    <section class="content">
    <div class="col-md-12">

        <?= Html::a('Create Ad', ['create'], ['class' => 'btn btn-success']) ?>
        <?= Html::a('View Ads', ['index'], ['class' => 'btn btn-info']) ?>
    </div>

    <div class="timeline-item">
        <h3 class="timeline-header ">Order wise categories</h3>
    </div>
    <?php

    $allCats = Category::find()->orderBy(['position' => SORT_ASC])->all();
    ?>
    <div class="row">

        <div class="col-md-2">
        <div class="form-group field-categorysearch-dinning has-success">

       <?php $form = ActiveForm::begin(['options' => ['class' => 'formSetOrder']]) ?>
        <select id="selectAdOrder" class="form-control" name="selectAdOrder">
        <option value="">Select Category</option>
        <?php
        foreach($allCats as $allCategories)
        {
        ?>
        <option value="<?php echo $allCategories->pkCategoryID;?>" <?php if((isset($model['formCategoryID'])) && ($allCategories->pkCategoryID == trim($model['formCategoryID']))){ echo 'selected';}?>><?php echo $allCategories->categoryName?></option>
        <?php 
        }
        ?>
        </select>
        <?php ActiveForm::end(); ?>
        <div class="help-block"></div>
        </div>         
        </div>
<div class="clearfix"></div>
    <div class="col-md-4 catsort">

    <div class="box">
    <div class="box-header">
              <h3 class="box-title">Arrange Ads</h3>
            </div>
    <ul class="mysort">
        <?php 
        //echo '<pre>'; print_r($model); echo '</pre>';
        if(isset($model[0])){
        $count = count($model) - 1;
        for($i=0; $i< $count; $i++)
        {
        ?>
        <li class="sortable-item" id="<?php echo $model[$i]->pkAdID;?>"><?php echo $model[$i]->title;?></li>
        <?php
        }
        }
        else
        {
        ?>
        <li class="sortable-item">No Result Found</li>
        <?php
        }
       ?>  
    </ul>
    <?php 
    if(isset($model[0])){
    ?>
       <button type="button" catid="<?php echo $model['formCategoryID'];?>" id="saveAdPosition" class="btn btn-block btn-success btn-lg">Save</button>
    <?php }?>
    </div>
    </div>
    </div>
    </section>

    

    
    
    
    

backend/views/ad/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model backend\models\Ad */

$this->title = 'Update Ad';
// $this->params['breadcrumbs'][] = ['label' => 'Ads', 'url' => ['index']];
// $this->params['breadcrumbs'][] = ['label' => $model->title, 'url' => ['view', 'id' => $model->pkAdID]];
// $this->params['breadcrumbs'][] = 'Update';
?>
<section class="content-header">
        <h1><?= Html::encode($this->title) ?></h1>
    </section>

<section class="content">
    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>
 </section>